=== modified file 'cmenu.ui'
--- cmenu.ui	2006-12-10 20:16:18 +0000
+++ cmenu.ui	2007-01-30 16:05:15 +0000
@@ -5,6 +5,7 @@
         <menuitem name="rename" action="rename" />
         <menuitem name="open" action="open" />
         <separator />
+        <menuitem name="revert" action="revert" />
         <menuitem name="commit" action="commit" />
         <separator />
         <menuitem name="diff" action="diff" />

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2007-01-30 15:15:28 +0000
+++ olive/__init__.py	2007-01-30 16:05:15 +0000
@@ -478,6 +478,7 @@
             m_add = menu.ui.get_widget('/context_right/add')
             m_remove = menu.ui.get_widget('/context_right/remove')
             m_rename = menu.ui.get_widget('/context_right/rename')
+            m_revert = menu.ui.get_widget('/context_right/revert')
             m_commit = menu.ui.get_widget('/context_right/commit')
             m_diff = menu.ui.get_widget('/context_right/diff')
             # check if we're in a branch
@@ -487,12 +488,14 @@
                 m_add.set_sensitive(True)
                 m_remove.set_sensitive(True)
                 m_rename.set_sensitive(True)
+                m_revert.set_sensitive(True)
                 m_commit.set_sensitive(True)
                 m_diff.set_sensitive(True)
             except bzrerrors.NotBranchError:
                 m_add.set_sensitive(False)
                 m_remove.set_sensitive(False)
                 m_rename.set_sensitive(False)
+                m_revert.set_sensitive(False)
                 m_commit.set_sensitive(False)
                 m_diff.set_sensitive(False)
 

=== modified file 'olive/menu.py'
--- olive/menu.py	2007-01-30 11:33:28 +0000
+++ olive/menu.py	2007-01-30 16:05:15 +0000
@@ -69,6 +69,10 @@
                                        _('Open'), None,
                                        _('Open the selected file'),
                                        self.open_file),
+                                      ('revert', None,
+                                       _('Revert'), None,
+                                       _('Revert the changes'),
+                                       self.revert),
                                       ('commit', None,
                                        _('Commit'), None,
                                        _('Commit the changes'),
@@ -193,6 +197,18 @@
             else:
                 launch(fullpath) 
 
+    def revert(self, action):
+        """ Right context menu -> Revert """
+        wt, path = WorkingTree.open_containing(self.path)
+        ret = wt.revert([os.path.join(path, self.selected)])
+        if ret:
+            warning_dialog(_('Conflicts detected'),
+                           _('Please have a look at the working tree before continuing.'))
+        else:
+            info_dialog(_('Revert successful'),
+                        _('All files reverted to last revision.'))
+        self.app.refresh_right()       
+    
     def commit(self, action):
         """ Right context menu -> Commit """
         from commit import CommitDialog

